#include <stdio.h>
#include <zapplication.h>
#include <qlabel.h>
#include <zsoftkey.h>
#include <zoptionsmenu.h>
#include <zscrollpanel.h>
#include <zmessagedlg.h>
#include <znoticedlg.h>
#include <zlabel.h>
#include <zpressbutton.h>
#include <zlineedit.h>
#include <zcheckbox.h>
#include <zmultilineedit.h>
#include <qlayout.h>
#include <zformcontainer.h>
#include "HelloWorldGUI.h"  

HelloWorldGUI::HelloWorldGUI(QWidget *parent, const char* name) :
    ZKbMainWidget(ZHeader::MAINDISPLAY_HEADER, parent, name, WType_TopLevel),
    myFullScreen(false) {

    setMainWidgetTitle("TestApp");
    ZSoftKey *cst = new ZSoftKey("CST_2A", this, 0);
    cst->setText(ZSoftKey::RIGHT, "Quit", ZSoftKey::ZERO);
    cst->setText(ZSoftKey::LEFT, "Menu", ZSoftKey::ZERO);
    
    cst->setClickedSlot(ZSoftKey::RIGHT, qApp, SLOT(quit()));
    
    QRect r(0, 0, 240, 320);
    ZOptionsMenu *menu = new ZOptionsMenu(r, this);
    menu->insertItem("sig0", 0, this, SLOT(slot_1()));
    menu->insertItem("sig1", 0, this, SLOT(slot_2()));
    menu->insertItem("msgdlg", 0, this, SLOT(slot_3()));
    menu->insertItem("noticedlg", 0, this, SLOT(slot_4()));

    cst->setOptMenu(ZSoftKey::LEFT, menu);
    setSoftKey(cst);
    
    ZFormContainer *main = new ZFormContainer(this);
    setContentWidget(main);
    
    ZLabel *l = new ZLabel("ZLabel", main, 0, 0, ZSkinService::clsZLineEdit);
    main->addChild(l, false, 0);

  #if 0
    ZPressButton *b = new ZPressButton("Text", main, 0, ZSkinService::clsZLineEdit);
    b->setTitle("Title");
    ZLineEdit *e = new ZLineEdit(main);
    ZCheckBox *c = new ZCheckBox("Text", main, 0);
    c->setChecked(true);
    c->setTitlePosition((ZCheckBox::TitlePosition)1);
    printf("%x\n", c->pixmap());
    c->setPixmap(QPixmap());
    printf("%x\n", c->pixmap());
  #endif
    ZMultiLineEdit *m = new ZMultiLineEdit(this, true, 4, 0);
    connect(this, SIGNAL(mySig0()), m, SLOT(undo()));
    connect(this, SIGNAL(mySig1()), m, SLOT(redo()));
    main->addChild(m, true, 0);    
}

void HelloWorldGUI::keyPressEvent(QKeyEvent *e)
{
  printf("press: %x\n", e->key());
}

void HelloWorldGUI::slot_1()
{
  emit mySig0();
}

void HelloWorldGUI::slot_2()
{
  emit mySig1();
}

void HelloWorldGUI::slot_3()
{
  ZMessageDlg dlg("Text1", "Text2", ZMessageDlg::TypeOK, 0, this, 0, true, 0);
  dlg.exec();
}

void HelloWorldGUI::slot_4()
{
  ZNoticeDlg::information("Msg1", QString::null, QString::null, "in_progress_ani_pop.gif", 0, 0);
}

void HelloWorldGUI::keyReleaseEvent(QKeyEvent *e)
{
  printf("release: %x\n", e->key());
}

HelloWorldGUI::~HelloWorldGUI() {

}
