#ifndef __ZBASEBUTTON_H__
#define __ZBASEBUTTON_H__

#include <zformitem.h>

class ZBaseButtonGroup;

// sizeof == 0x100
class ZBaseButton : public ZFormItem {
  Q_OBJECT
  public:
    enum ToggleType {
      SingleShot, Toggle, Tristate
    };
    
    enum ToggleState {
      Off, NoChange, On
    };
    
    QPixmap *pixmap() const;
    QString text() const;
    bool isOn() const;

  protected:
    // sub_41a3ef4c sub_ (05r)
    ZBaseButton(QWidget *p, const char *n, unsigned f,
        ZSkinService::WidgetClsID c) : ZFormItem(p, n, f, c) {}

    // sub_41a3f290, sub_41a3f37c (05r)
    virtual ~ZBaseButton() {}

    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void enabledChange(bool);
    virtual bool focusNextPrevChild(bool);

    // names for inlined methods getted from ZPressButton vtable
    
    // really this two are not empty
    virtual void setText(QString const &) {}
    virtual void setPixmap(QPixmap const &) {}
    
    virtual void setAccel(int);
    virtual void setDown(bool);
    virtual void setAutoResize(bool);
    virtual void setAutoRepeat(bool);
    virtual void setToggleType(ZBaseButton::ToggleType);
    virtual void setState(ZBaseButton::ToggleState);
    virtual void hitButton(QPoint const&) const;
    
    // this two are really empty
    virtual void drawButton(QPainter *) {}
    virtual void drawButtonLabel(QPainter *) {}
    
    virtual void setGroup(ZBaseButtonGroup*);

  /* 'hidden' slots:
   * animatedClick()
   * toggle()
   * animateTimeout()
   * autoRepeatTimeout()
   * */

  signals:
    void pressed();
    void released();
    void clicked();
    void toggled(bool);
    void stateChanged(int);
  
  private:
    char _zbasebutton_stuff[0x100 - sizeof(ZFormItem)];
};

#endif
