#ifndef __ZCHECKBOX_H__
#define __ZCHECKBOX_H__

#include <qpixmap.h>
#include <zbasebutton.h>

// sizeof == sizeof(ZBaseButton) + 4
// what the fuck is shown by IDA in vtable + QWidget::resizeEvent slot ?
class ZCheckBox : public ZBaseButton {
  Q_OBJECT
  public:
    enum TitlePosition {
      TitleTop, TitleLeft
    };

    ZCheckBox(QWidget*, char const*);
    ZCheckBox(QString const&, QWidget*, char const*);

    void setTitle(QString const&);
    bool isChecked() const;
    void setChecked(bool);

    // just store param in pdata + 0x14 and call QWidget::update
    void setTitlePosition(ZCheckBox::TitlePosition param);
    
    int getTextHeight() const;
    QRect getTitleRect() const;
    QSize getTitleSize() const;

    // virtual void setText(QString const&) not changed

    // reimplementation of basic method (not exported by dso)
    // looks like this
    // (really function from ZCheckBox::vtable will be called
    // if you doesn't call setPixmap from constructor of derived class,
    // otherwise this (if you didn't reimplement method)
    // and you'll get nothing usefull)
    virtual void setPixmap(QPixmap const &pix)
    {
    #if 0
      #define PDATA (unsigned *)_zcheckbox_stuff
      QPixmap *p = (QPixmap *)((char *)*PDATA + 8);
      
      if(p) delete p;
      p = new QPixmap(pix);
    #endif
    }
    
    QPixmap *pixmap() const;

  protected:
    virtual ~ZCheckBox() {}
    QRect getCheckBtnRect() const;
    QRect getContentRect() const;
    void getFrameWidth(int&, int&, int&, int&) const;
    void setNoChange();

  /* 'hidden' slots:
   * setEnabled(bool)
   * slotStateChanged(int)
   * */

  private:
    char _zcheckbox_stuff[4];
};

#endif
