#ifndef __ZFORMCONTAINER_H__
#define __ZFORMCONTAINER_H__

#include <zscrollpanel.h>

class ZFormItem;
class ZCheckBox;
class ZGroupBox;
class ZLineEdit;
class ZSeparator;
class ZMultiLineEdit;
class ZExhibitButton;

// sizeof == sizeof(ZScrollPanel) + 4
class ZFormContainer : public ZScrollPanel {
  Q_OBJECT
  public:
    ZFormContainer(QWidget* = 0, unsigned int = 0,
        ZSkinService::WidgetClsID = ZSkinService::clsZFormContainer);
    virtual ~ZFormContainer();
    
    void addChild(ZFormItem*, bool adjustWidth, ZWidget *placeBeforeThisWidget = 0);
    void addChild(ZCheckBox*, bool, ZWidget* = 0);
    void addChild(ZMultiLineEdit*, bool, ZWidget* = 0);
    void addChild(ZLineEdit*, bool, ZWidget* = 0);
    void addChild(ZWidget*, bool, ZWidget* = 0);

  protected:
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void setPalette(QPalette const&);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void updateSkin(bool);
    virtual void removeChild(ZWidget*);
    void triggerUpdate(bool);
    
    void addChild(ZGroupBox*, bool, ZWidget*);
    void addChild(ZSeparator*, bool, ZWidget*);
    void addChild(ZExhibitButton*, bool, ZWidget*);
  
  protected slots:
    virtual void slotResizeChild();
  
  /* 'hidden' slots:
   * slotLayoutTimer()
   * */

  private:
    char _zformcontainer_stuff[4];
};

#endif
