#ifndef __ZIMAGE_H__
#define __ZIMAGE_H__

#include <zwidget.h>

class QMovie;

// sizeof == 0x100
class ZImage : public ZWidget {
  Q_OBJECT
  public:
    ZImage(QWidget*, char const*, unsigned int);
    ZImage(QPixmap&, QWidget*, char const*, unsigned int);
    virtual ~ZImage();
    
    // if movie already exists then delete old_movie
    // this+0xf0 = new QMovie(movie);
    // make some actions
    void setMovie(QMovie const &movie);
    
    QMovie *movie() const;
    void getFrameWidth(int&, int&, int&, int&) const;
    
    // if pixmap already exists and old_pixmap->d->ser_no != pix.d->ser_no
    // then delete old_pixmap
    // old_pixmap == 0 ? this+0xec = new QPixmap(pix) : ;
    // make some actions
    void setPixmap(QPixmap const &pix);
    
    QRect getContentRect();

  protected:
    virtual void setEnabled(bool);
    virtual void setPalette(QPalette const&);
    virtual void resize(int, int);
    virtual void setGeometry(int, int, int, int);
    virtual void setGeometry(QRect const&);
    virtual QSize sizeHint() const;
    virtual void paintEvent(QPaintEvent*);

  protected slots:
    void movieUpdated(const QRect&);
    void movieResized(const QSize&);

  signals:
    void sizeChanged(const QSize&);

  private:
    char _zimage_stuff[0x100 - sizeof(ZWidget)];
};
#endif
