#ifndef __ZKBMAINWIDGET_H__
#define __ZKBMAINWIDGET_H__

#include <zheader.h>
#include <zmainwidget.h>
#include <zappinfoarea.h>
#include <zsoftkey.h>

// sizeof == sizeof(ZMainWidget) + 4
class ZKbMainWidget : public ZMainWidget {
  Q_OBJECT
  public:
    ZKbMainWidget(ZHeader::HEADER_TYPE, QWidget*, char const*, unsigned int);
    ZKbMainWidget(QWidget*, char const*, unsigned int);
    ZKbMainWidget(QString const&, QWidget*, char const*, unsigned int);
    virtual ~ZKbMainWidget();
    
    QSize headerSize();
    ZHeader *getHeader();
    static int setAppTitle(QString const&); // 1
    static QString getAppTitle();
    
    // return ZHeader::switchHeader();
    int setHeaderType(ZHeader::HEADER_TYPE);
    
    int setMainWidgetTitle(QString const&); // 0 / 1
    QString getMainWidgetTitle();
    int setMainWidgetTitleIcon(QPixmap const&); // 0 / 1
    QPixmap getMainWidgetTitleIcon();
    
    // w == 0 ? new ZSoftKey : ;
    // return ZMainWidget::setCSTWidget(w);
    int setSoftKey(ZSoftKey *w);
    
    // getCSTWidget(0) == 0 && create ? setSoftKey(0) : ;
    ZSoftKey *getSoftKey(bool create);
    
    // w == 0 ? new ZAppInfoArea : ;
    // return setTitleBarWidget(w);
    void setAppInfoArea(ZAppInfoArea *w);
    
    // return ZMainWidget::getTitleBarWidget();
    QWidget *getAppInfoArea();
    
    // return ZHeader::setTruncEnable(enabled);
    void setTitleTruncEnable(bool enabled);
    
    // return ZHeader::isTruncEnable();
    bool isTitleTruncEnable();
    
    // return ZHeader::hide();
    void HideHeader();
    
    // return ZHeader(QWidget)::update();
    void updateHeader();

  protected:
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual int getLRSBaseIndex(); // 0 / 1
    
    void init(ZHeader::HEADER_TYPE);

  protected slots:
    void slotFullScreenModeChanged(bool);
    void slotAppMessage(QCString const&, QArray<char> const&);

  signals:
    void clearKeyClicked();
    void serverInitialized();

  private:
    char _zkbmainwidget_stuff[4];
};

#endif
