#ifndef __ZMAINWIDGET_H__
#define __ZMAINWIDGET_H__

#include <quuid.h>
#include <zwidget.h>

class QVBoxLayout;
class QUuid;

// sizeof == sizeof(ZWidget) + 4 (0xf0)
class ZMainWidget : public ZWidget {
  Q_OBJECT
  public:
    ZMainWidget(QString const&, bool, QWidget*, char const*, unsigned int);
    ZMainWidget(QWidget*, char const*, unsigned int);
    ZMainWidget(bool, QWidget*, char const*, unsigned int);
    virtual ~ZMainWidget();

    virtual bool eventFilter(QObject*, QEvent*);
    virtual void show();
    virtual void hide();
    virtual void paletteChange(QPalette const &);
    virtual bool setContentWidget(QWidget *w); // w == 0 ? new ZScrollPanel : ;
    
    // if cst doesn't exist and create is true
    // then call setCSTWidget(0) (from vtable, not ZMainWidget::func)
    virtual QWidget *getCSTWidget(bool create); 
    virtual bool setCSTWidget(QWidget *w); // w == 0 ? new QFrame : ;
    virtual bool setTitleBarWidget(QWidget *w); // w == 0 ? new QLabel : ;
    virtual void setFullScreenMode(bool enabled, bool not_used = true);
    
    QWidget *getTitleBarWidget();
    
    // if content doesn't exist and create is true
    // then call setContentWidget(0) (from vtable, not ZMainWidget::func)
    QWidget *getContentWidget(bool create);
    bool getFullScreenMode();
    QVBoxLayout *getVBoxLayout();
    
  protected slots:
    virtual void hideInputWidget();   // empty
    virtual void slotPopupMenu(int);  // empty
    virtual void invokeInputWidget(); // empty

  /* 'hidden' slots:
   * slotKbWidgetSizeChanged(const QRect&,int,bool,bool)
   * slotKbStateChanged(bool,const QUuid&,int)
   * popupKbMenu()
   * objectDestroyed()
   * */
  
  protected:
    virtual int showToolBar(); // empty, return 0
    virtual void sub_ezxappbase_41a90e0c() {}
    virtual int hideToolBar(); // empty, return 0
    virtual void setupInputMethodsPopupMenu(); // empty
    virtual int getLRSBaseIndex(); // empty, return 0
  
    void getFavoriteInputMethods() const; // empty

    void showWithInputMethod(QUuid const& not_used, int not_used); // useless
    void setInputMethod(QUuid const&, int); // empty
    void setInputMethods(QWidget*, QUuid const&, QValueList<QUuid> const&, int, QString);
    bool getEditMode();
    bool getKbState();
    void setInputMethods(QWidget*, QUuid const&, int, QString);
    void setInputMethod(QWidget*, QUuid const&, int, QString);

  signals:
    void kbStateChanged(bool, const QUuid &, int);
    void kbStateChanged(bool);
    void fullScreenModeChanged(bool);
    void mainWidgetSizeChanged(int, const QRect &);

  private:
    char _zmainwidget_stuff[4];
};

#endif
