#ifndef __ZMULTILINEEDIT_H__
#define __ZMULTILINEEDIT_H__

#include <ztableview.h>

class QValidator;
class TsLayoutInfo;
class TsLayout_;
class ZMultiLineEditCommand;

// sizeof == 0x1a8
class ZMultiLineEdit : public ZTableView {
  Q_OBJECT
  public:
    enum TitlePosition {
    };

    enum CursorFlagDirection {
    };

    enum CursorFlagExist {
    };

    enum InitAutoAlign {
    };

    enum EchoMode {
    };

    enum WrapPolicy {
    };

    enum TextType {
    };

    enum eParaAlignment {
    };

    enum InsertionMethod {
    };

    enum WordWrap {
    };

    ZMultiLineEdit(QWidget*, char const*);
    ZMultiLineEdit(QWidget*, bool, int, char const*);
    virtual ~ZMultiLineEdit();
  
  protected:
    struct ZMultiLineEditRow {
    };

    virtual bool event(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void setPalette(QPalette const&);
    virtual void setFont(QFont const&);
    virtual void show();
    virtual QSize sizeHint() const;
    virtual QSize minimumSizeHint() const;
    virtual QSizePolicy sizePolicy() const;
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void updateMask();
    virtual bool focusNextPrevChild(bool);
    virtual void updateSkin(bool);
    virtual void setAutoUpdate(bool);
    virtual void paintCell(QPainter*, int, int, int, int);
    virtual void drawTableFrame(QPainter*, QRect&);
    
    virtual void insertLine(QString const&, int);
    virtual void insertAt(QString const&, int, int, bool);
    virtual void removeLine(int);
    virtual void setCursorPosition(int, int, bool);
    virtual void setFixedVisibleLines(int);
    virtual void setValidator(QValidator const*);
    virtual void setInsertionMethod(ZMultiLineEdit::InsertionMethod);
    virtual void setEchoMode(ZMultiLineEdit::EchoMode);
    virtual void setFontPercent(float);
    virtual void setMaxLineLength(int);
    virtual void setMaxLines(int);
    virtual void setHMargin(int);
    virtual void setSelection(int, int, int, int);
    virtual void resetFocusItem(bool);
    virtual void getCurrentFocusRect();
    virtual void hasNextPrevFocusItem(bool);
  
  protected slots:
    virtual void changeContentSize(int, QPoint);
    virtual void setText(QString const&);
    virtual void setReadOnly(bool);
    virtual void setZEnabled(bool);
    virtual void setOverwriteMode(bool);
    void clear();
    void append(QString const&);
    void selectAll();
    void deleteText();
    void insert(QString const&);

  /* 'hidden' slots:
   * isZEnabled()
   * isZDisabled()
   * deselect()
   * smartPunctuation()
   * paste()
   * pasteSubType(const QString&)
   * copyText()
   * copy()
   * cut()
   * undo()
   * redo()
   * clipboardChanged()
   * blinkTimerTimeout()
   * scrollTimerTimeout()
   * dndTimeout()
   * fastDelTimerTimeout()
   * bufferUpdate()
   * */

  signals:
    void clicked();
    void textTrancated();
    void textChanged();
    void returnPressed();
    void undoAvailable(bool);
    void redoAvailable(bool);
    void copyAvailable(bool);
    void cursorChanged(int, int);
    void bufferUpdated(int, int);
    void contentChanged();
    void changeSizeHint(QWidget *, QSize, QPoint, int);
    void lineChanged(int, QPoint);
    void rightSmartPuncOccured();
    void sigCursorUpDown(bool);
    void contentsResizing(ZMultiLineEdit*, int, int);
    
  protected:
    virtual void drawLineText(QPainter*, int, int, int, int, int, QString const&, int, int);
    virtual void insert(QString const&, bool);
    virtual void newLine();
    virtual void killLine();
    virtual void pageUp(bool);
    virtual void pageDown(bool);
    virtual void cursorLeft(bool, bool, bool);
    virtual void cursorRight(bool, bool);
    virtual void cursorUp(bool);
    virtual void cursorDown(bool);
    virtual void cursorMove(bool);
    virtual void backspace();
    virtual void del();
    virtual void home(bool);
    virtual void end(bool);
    
    void getFormItemLeftArea();
    void cursorUp(bool, bool);
    void handleEzxInsertString(ZMultiLineEdit::ZMultiLineEditRow*, QString const&, int);
    void getString(int) const;
    void cursorWordForward(bool);
    void setTitlePosition(ZMultiLineEdit::TitlePosition);
    void getFilter() const;
    void hMargin() const;
    void getInputField();
    void getFormItemBottomArea();
    void rebreakLines(ZMultiLineEdit::ZMultiLineEditRow*&, TsLayoutInfo&, TsLayout_*, int, int&, int&, QString const&, QString const&);
    void addUndoCmd(ZMultiLineEditCommand*);
    void getHeight() const;
    void getWidth() const;
    void getMDTopArea();
    void echoMode() const;
    void setCursorFlagDirection(ZMultiLineEdit::CursorFlagDirection);
    void insertChar(QChar);
    void setCursorFlagExist(ZMultiLineEdit::CursorFlagExist);
    void getOffset(int);
    void setFilter(QRegExp const&, bool);
    void killLineAux();
    void setInitAutoAlign(ZMultiLineEdit::InitAutoAlign);
    void handleNormalInsertString(ZMultiLineEdit::ZMultiLineEditRow*, QString const&, int, int);
    void getTitleSize() const;
    void getEditArea();
    void getCursorOffset(int, int);
    void getMDLeftArea();
    void setNestScrollPanelMode(bool);
    void textWidth(int);
    void getUnderline();
    void setEdited(bool);
    void clearUndoList();
    void atEnd() const;
    void getLineCount();
    void setWrapPolicy(ZMultiLineEdit::WrapPolicy);
    void cursorRight(bool, bool, bool);
    void insertAtAux(QString const&, int, int, bool);
    void getLineContent(int);
    void doEnterCharBreak(ZMultiLineEdit::ZMultiLineEditRow*&, int, bool, int, int&, int&, int&, int&, int&, int&, QString&);
    void getFormItemRightArea();
    void getSkinFont(QFont&, QColor&, ZMultiLineEdit::TextType) const;
    void getCursorPosition(int*, int*) const;
    void getFrameWidth(int&, int&, int&, int&);
    void atBeginning() const;
    void insertString_if(QPoint, QString);
    void stringShown(int) const;
    void numLines() const;
    void overrideLineDirection(int, ZMultiLineEdit::eParaAlignment, int);
    void setTitlePositionAux(QString const&, int);
    void maxLength() const;
    void cursorDown(bool, bool);
    void insertAtNew(QString const&, int, int, bool);
    void getContentsWidth();
    void length() const;
    void processCmd(ZMultiLineEditCommand*, bool);
    void textWidthWithTabs(int);
    void getMarkedRegion(int*, int*, int*, int*) const;
    void phonenoText() const;
    void setUnderline(bool);
    void backspaceNew();
    void getRowString(int);
    void setMaxLength(int);
    void getMDRightArea();
    void deleteWord();
    void getIndent();
    void validator() const;
    void insertAtSpecialEzxStyle(QString const&, int);
    void textLine(int) const;
    void getParaAlignment();
    void getPixmap(ZSkinBase::SelectionState);
    void getTruncateCount();
    void cursorLeft(bool, bool);
    void getMDFrameWidth(int&, int&, int&, int&);
    void getLinePixSuffixName(ZSkinBase::SelectionState, QString&);
    void getLineHeight() const;
    void addRedoCmd(ZMultiLineEditCommand*);
    void getCursorState();
    void lineLength(int) const;
    void isReadOnly() const;
    void getMDBottomArea();
    void setTitle(QString const&);
    void text() const;
    void deleteNextChar(int, int, int);
    void setWordWrap(ZMultiLineEdit::WordWrap);
    void getInputModeCursorModel();
    void delAux();
    void getFormItemTopArea();
    void maxLineLength() const;
    void paintCell_if(QPainter*, int, int, bool, int, bool, int, int, QString, QFontMetrics, QRect, QColorGroup);
    void getCorsorPosition(int&, int&, int);

  private:
    char _zmultilineedit_stuff[0x1a8 - sizeof(ZTableView)];
};

#endif
