#ifndef __ZNOTICEDLG_H__
#define __ZNOTICEDLG_H__

#include <zpopup.h>

// sizeof == sizeof(ZPopup) + 4
class ZNoticeDlg : public ZPopup {
  Q_OBJECT
  public:
    enum Type {
      Success,
      Information
    };
    
    ZNoticeDlg(ZNoticeDlg::Type, QString const&, QString const&, QWidget*, char const*, bool, unsigned int, bool);
    ZNoticeDlg(ZNoticeDlg::Type, unsigned int, QString const&, QString const&, QWidget*, char const*, bool, unsigned int);
    virtual ~ZNoticeDlg();
    
    void setAutoDismissTime(int);
    void setMessageText(QString const&);

    // dinamically creates ZNoticeDlg (and deletes it at exit)
    // slot != 0 ? connected to dlgDismissed() : ;
    // tm_hide = 0
    static void information(QString const &text1, QString const &text0, QString const &movie,
        QString const &titleIcon, QObject const *obj, char *slot);
  
  protected:
    virtual void setPalette(QPalette const&);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void showEvent(QShowEvent*);
    
    void initialize(ZNoticeDlg::Type);

  protected slots:
    virtual void slotResizeAllChild(int);

  /* 'hidden' slots:
   * slotTimeout()
   * */

  signals:
    void dlgDismissed();

  private:
    char _znoticedlg_stuff[4];
};
#endif
