#ifndef __ZOPTIONSMENU_H__
#define __ZOPTIONSMENU_H__

#include <qlist.h>
#include <zwidget.h>

class ZOptionsMenu;
class ZOptMenuParser;
class MenuItem;

// sizeof == 8 (vtable ptr + 4)
class ZOptionsMenuItem {
  public:
    virtual ~ZOptionsMenuItem();
    QString text() const;
    ZOptionsMenu *subMenu() const;

  protected:
    ZOptionsMenuItem(ZOptionsMenu *) {} // sub_419E5D88 ?
    virtual void sub_ezxappbase_419e8fcc() {}
    virtual void sub_ezxappbase_419e63ac() {}

  private:
    char _zoptionsmenuitem_stuff[4];
};

// sizeof == sizeof(ZWidget) + 4 (0xf0)
class ZOptionsMenu : public ZWidget {
  Q_OBJECT
  public:
    enum CornerE {
      TopLeft, TopRight, BottomLeft, BottomRight
    };

    // doesn't call ZOptionsMenu::init(r) if last param is false
    ZOptionsMenu(QRect &r, QWidget *papa, char const* = 0, unsigned int = 0,
        ZSkinService::WidgetClsID = ZSkinService::clsZOptionsMenu, bool init = true);
    
    // load menu from config file ?
    ZOptionsMenu(QRect&, QWidget*, char const*, unsigned int, ZSkinService::WidgetClsID, QString, QString);
    
    virtual ~ZOptionsMenu();

    virtual void setPalette(QPalette const&);
    
    void setParentMenu(ZOptionsMenu *);
    ZOptionsMenu *getParentMenu() const;
    void clear();
    unsigned count();
    int getIdFromIndex(int index); // -1 on failure
    int getIndexFromId(int id);    // -1 on failure
    int insertItem(QString const&, ZOptionsMenu*, QPixmap const*, bool enabled,
        int desired_id, int desired_idx, bool = false,
        bool = false, bool = false); // ret item id
    int insertItem(QString const&, QPixmap const*, QObject const *obj,
        char const *obj_slot, bool enabled = true, bool = false, bool = false,
        int = -1, int = -1, bool = false); // ret item id
    
    // if(!w) return;
    void setItemSubMenu(int id, ZOptionsMenu *w);
    ZOptionsMenu *getItemSubMenu(int id);

  public slots:
    virtual void show();
    virtual void hide();
    void popup();

  /* 'hidden' slots:
   * objectDestroyed()
   * */

  protected:
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void fontChange(QFont const&);
    
    virtual void setActiveItem(int);
    virtual void setPosition(ZOptionsMenu::CornerE, QPoint&);
    virtual void drawScrollIndicator(QPainter*);
    virtual void init(QRect&);
    virtual void genMenu(QRect&, QList<MenuItem>);
    virtual void initShow();
    virtual void updateSize();

    ZOptionsMenu(QRect&, QWidget*, char const*, unsigned int, ZSkinService::WidgetClsID, ZOptMenuParser*, QString, bool = true);
    
    void setLimitRect(QRect const&);
    void setLimitRect(int);
    void limitRect() const;
    void getActiveItemId();
    void getCurrentSelectedItemId();
    void getAllItemIds();
    void setMenu(ZOptMenuParser*, QString);
    ZOptionsMenuItem *findItem(int id, ZOptionsMenu**) const;
    void setDisabledReasonDlgTitle(int, QString const&);
    void setDisabledReason(int, QString const&);
    void setItemHide(int, bool);
    void isItemHided(int) const;
    void setItemEnabled(int, bool);
    void isItemEnabled(int) const;
    void changeItem(int, QString const&, QPixmap const*);
    void setItemChecked(int, bool);
    void setItemCheckable(int, bool);
    void connectItem(int, QObject const*, char const*);
    void removeItemFromVisibleList(ZOptionsMenu*, ZOptionsMenuItem*);
    void resetHS(ZOptionsMenu*);
    void getMenuDisplayState(ZOptionsMenu*);
    void getItemSubMenuNum(int);
    void disconnectItem(int, QObject const*, char const*);
    void getItemParentId(int);
    void insertItem(ZOptionsMenuItem*, int, int);
    void ItemState(ZOptionsMenu*, ZOptionsMenu*, MenuItem*);
    void removeItem(int, bool);
    void getListFromConfig(QList<MenuItem>&, QString, QString);
    void setMenu(QString, QString);

  signals:
    void aboutToHide();
    void aboutToShow();
    void activated(int);
    void canceled();
    void highlighted(int);
    void lSoftkeyDown();
    void lSoftkeyUp();
    void rSoftkeyDown();
    void rSoftkeyUp();
    void rSoftkeyUpL();

  private:
    char _zoptionsmenu_stuff[4];
};

#endif
