#ifndef __ZPOPUP_H__
#define __ZPOPUP_H__

#include <qdialog.h>
#include <zwidgetskinprops.h>

class ZWidget;
class ZFormContainer;
class ZIconView;
class ZDetailView;
class ZPopupHeader;
class ZLabel;
class ZSoftKey;

enum UNS_PRIO_T {
};

// sizeof == sizeof(QDialog) + 8 (0xC0)
class ZPopup : public QDialog {
  Q_OBJECT
  public:
    enum POPUP_TYPE_E {
      DIALOG, NOTICE
    };
    
    ZPopup(ZPopup::POPUP_TYPE_E, QWidget*, char const*, bool, int, unsigned int);
    virtual ~ZPopup();
    
    int exec();
    
    void setTitle(QString const&);
    void setInstructText(QString const&);
    void setSoftkeyText(QString const &left, QString const &right);
    ZPopupHeader *getPopupHeader();
    void setInstructAlign(Qt::AlignmentFlags);
    void setInstructFont(QFont const&);
    
    // icon name from iconres (i.e. in_progress_ani_pop.gif (from phone))
    void setTitleIcon(QString const&);
    void setSoftkeyTextRight(QString const&);
    void setSoftkeyTextLeft(QString const&);
    void setInstructFontColor(QColor const&);
    ZSoftKey *getSoftKey();
    QString getTitle();
    ZLabel *getInstructionLabel() const;

  protected:
    virtual void timerEvent(QTimerEvent*);
    virtual void setPalette(QPalette const&);
    virtual void show();
    virtual void keyPressEvent(QKeyEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void customEvent(QCustomEvent*);
  
    virtual void doLayout(bool);
  
  protected slots:
    virtual void done(int);
    virtual void accept();
    virtual void reject();
    virtual void slotLSKClicked();
    virtual void slotRSKClicked();
    virtual void slotResizeAllChild(int);

  /* 'hidden' slots:
   * slotSPC_resize(ZScrollPanel*,int,int)
   * slotSocketConnected()
   * slotSocketReadyRead()
   * slotConnectionClosed()
   * slotFlipOnOff(int)
   * */
  
  protected:  
    void setBypassSIMLock(bool);
    void insertChild(ZWidget*, int);
    void getAppInfoArea();
    void getBody() const;
    void getBodyAvailableWidth() const;
    void showUNSDlg(bool);
    void setBodyPadding(ZWidgetPaddingInfo const&);
    void setUNSFlag(UNS_PRIO_T);
    void insertChild(ZFormContainer*, int);
    void getUNSFlag();
    void setAutoDismissTime(int);
    void setScrollable(bool);
    void getInstructAlign() const;
    void setBodyVSpacing(int);
    void enableAia(bool);
    void insertChild(ZIconView*, int);
    void getChildrenMaxWidth();
    void setInstructPadding(ZWidgetPaddingInfo const&);
    void getBypassSIMLock();
    void setTitleIcon(QPixmap const&);
    void setInsTruncPolicy(bool);
    void getScrollable();
    void setReturnIdlePolicy(int, bool);
    void setTransparentConner();
    void getBodyAvailableHeight();
    void insertChild(ZDetailView*, int);

  signals:
    void rightSoftkeyClicked();
    void leftSoftkeyClicked();
    void signalClearKeyPressed();
    void askReturnToIdle(int);
    void dlgAboutToShow();
    void dlgAboutToHide(int);

  private:
    char _zpopup_stuff[8];
};
#endif
