#ifndef __ZSKINBASE_H__
#define __ZSKINBASE_H__

#include <zskinservice.h>
#include <zwidgetskinprops.h>

class ZWidget;
class QWidget;

// sizeof == 0x3c
class ZSkinBase {
  public:

    struct BorderPixmaps {
    };

    enum BorderSide {
    };

    enum SelectionState {
    };

    ZSkinBase(ZWidget&, ZSkinService::WidgetClsID, bool);
    ZSkinBase(QWidget&, ZSkinService::WidgetClsID, bool);
    virtual ~ZSkinBase();
    
  protected:
    void setWidgetPixmapPrefix(QString&);
    void loadBorderPixmaps(ZSkinBase::BorderPixmaps&) const;
    void enableCache(bool);
    void getProps() const;
    void getPixmapNameByState() const;
    void getWallPaper(QPainter&) const;
    void drawBorder(QPainter&, QRect const*);
    void getBackgroundBlendingPercent();
    void setBlendingPercent(unsigned int);
    void getParentBackImage(ZWidget&, int, int, int&, int&, bool&);
    void getBorderWidth(ZSkinBase::BorderSide) const;
    void getBlendingPercent();
    void setZBackground(QPixmap&);
    void setZBorder(ZSkinBase::BorderPixmaps&);
    void drawBorder(QPainter&, ZWidget&, QRect const*, bool);
    void selectionState() const;
    void setPadding(ZWidgetPaddingInfo const&);
    void setPixmapID(QString, QString);
    void getBorderBlendingPercent();
    void setZBorder(ZWidgetBorderInfo*);
    void setZBackground(ZWidgetBackgroundInfo*);
    void setSelectionState(ZSkinBase::SelectionState);
    void getBackgroundType() const;
    void getBorderType() const;
    void padding() const;
    void drawBorder(QPainter&, QRect&, QPixmap*, int, int, int);
    void setPixmapPrefix(QString&);
    void drawBackgroundAndBorder(QPainter&, ZWidget&, QRect const*, bool);
    void updateSkin();
  
  private:
    char _zskinbase_stuff[0x3c - 4]; // -4 - vtable ptr
};

#endif
