#ifndef __ZSOFTKEY_H__
#define __ZSOFTKEY_H__

#include <zwidget.h>

class QString;
class ZOptionsMenu;

// sizeof == sizeof(ZWidget) + 4
class ZSoftKey : public ZWidget {
  Q_OBJECT
  public:
    enum KEY_IDX {
      LEFT, RIGHT, MID
    };

    enum TEXT_PRIORITY {
      ZERO, ONE, TWO
    };

    ZSoftKey(QString const&, QWidget*, QWidget*);

    ZOptionsMenu *getOptMenu(ZSoftKey::KEY_IDX);
    
    virtual void setText(ZSoftKey::KEY_IDX, QString const&, ZSoftKey::TEXT_PRIORITY);
    
    void setClickedSlot(ZSoftKey::KEY_IDX, QObject const *obj, char const *slot);
    void showButton(ZSoftKey::KEY_IDX, bool show);

    // call ZSoftButton(QWidget)::setEnable(enable);
    void setButtonEnable(ZSoftKey::KEY_IDX, bool enable);
    
    // QWidget::isEnabled()
    bool isButtonEnabled(ZSoftKey::KEY_IDX);
    
    // w == 0 ? delete (?) : ;
    void setOptMenu(ZSoftKey::KEY_IDX, ZOptionsMenu *w);

  protected slots:
    void slotBtnReleased(KEY_IDX);
    void slotBtnPressed(KEY_IDX);

  /* 'hidden' slots:
   * slotBtnClicked(KEY_IDX)
   * slotLeftKeyPressed()
   * slotLeftKeyReleased()
   * slotRightKeyPressed()
   * slotRightKeyReleased()
   * slotMenuHide()
   * slotMenuShow()
   * */

  protected:
    virtual void sub_ezxappbase_419d1b64() {}
    virtual void sub_ezxappbase_419d2954() {}
    virtual void sub_ezxappbase_419d136c() {}
    virtual void sub_ezxappbase_419d0e84() {}

    virtual ~ZSoftKey() {}
    
    void prevText(ZSoftKey::KEY_IDX);
    void prevClickedSlot(ZSoftKey::KEY_IDX);
    void setResourceID(ZSoftKey::KEY_IDX, QString const&, ZSoftKey::TEXT_PRIORITY);
    void enableClickedSlot(ZSoftKey::KEY_IDX);
    void disableClickedSlot(ZSoftKey::KEY_IDX);
    void setBgOverlapPixmap(ZSoftKey::KEY_IDX, QPixmap const&, int);
    void setTextForOptMenuHide(QString const&);
    void setTextForOptMenuShow(QString const&, QString const&);
    void setTextSelfShow(int);

  private:
    char _zsoftkey_stuff[4];
};

#endif
