#ifndef __ZTABLEVIEW_H__
#define __ZTABLEVIEW_H__

#include <zwidget.h>

// sizeof == 0x144
class ZTableView : public ZWidget {
  Q_OBJECT
  protected:
    // last two set to such value in ZMultiLineEdit(), c = 0x33
    // sub_4190efd4 (05r)
    ZTableView(QWidget *p, char const *n, uint f = 0xc00000,
        ZSkinService::WidgetClsID c = ZSkinService::clsZMeter)
      : ZWidget(p, n, f, c) {}

    virtual ~ZTableView() {}
    virtual void setBackgroundColor(QColor const&);
    
    virtual void setNumRows(int, bool);
    virtual void setNumCols(int);
    virtual void setTopCell(int);
    virtual void setLeftCell(int);
    virtual void setTopLeftCell(int, int);
    virtual void setXOffset(int);
    virtual void setYOffset(int);
    virtual void setOffset(int, int, bool);
    virtual void cellWidth(int);
    virtual void cellHeight(int);
    virtual void setCellWidth(int);
    virtual void setCellHeight(int);
    virtual void totalWidth();
    virtual void totalHeight();
    virtual void setTableFlags(unsigned int);
    virtual void setAutoUpdate(bool) {}
    virtual void paintCell(QPainter*, int, int, int, int);
    virtual void paintCell(QPainter*, int, int);
    virtual void setupPainter(QPainter*);
    virtual void drawTableFrame(QPainter *, QRect &) {}
    virtual void setHorScrollBar(bool, bool);
    virtual void setVerScrollBar(bool, bool);
 
  /* 'hidden' slots:
   * horSbValue(int)
   * horSbSliding(int)
   * horSbSlidingDone()
   * verSbValue(int)
   * verSbSliding(int)
   * verSbSlidingDone()
   * */

  private:
    char _ztableview_stuff[0x144 - sizeof(ZWidget)];
};

#endif
