#ifndef __ZWIDGET_H__
#define __ZWIDGET_H__

#include <qwidget.h>
#include <zskinbase.h>

class QPixmap;

// sizeof == 0xec
class ZWidget : public QWidget, public ZSkinBase {
  Q_OBJECT
  public:

    enum ResizeMethod {
      ResizeByDefault, ResizeByParent, ResizeByContent, FixedSize
    };

    enum LayoutDirection {
      DefaultLayout, LeftToRight, RightToLeft, CachedLtoR, CachedRtoL
    };

    ZWidget(QWidget*, char const*, unsigned int, ZSkinService::WidgetClsID);
    virtual ~ZWidget();

  protected:
    virtual void updateSkin(bool call_qwidget_update);
    virtual QPixmap *getBgImageForTransparent(bool&);

    virtual void sub_ezxappbase_4198c8ec() {}
    
    // virtual void sub_ezxappbase_4198c920();
    // normal name appears in ZScrollPanel vtable
    virtual bool isScrollPanelTypeWidget() { return false; }
    
    virtual void sub_ezxappbase_4198c928() {}

    virtual int getStepInScrollPanel(bool) const; // empty, return 0x14
    virtual void drawBackgroundAndBorder(QPainter&, QRect const*);
    virtual void drawBorder(QPainter&, QRect const*);
    virtual void drawBackground(QPainter&, QRect const*, bool);
    
    void setScrolledInPanel(bool);
    void setAutoAdjustWidthInPanel(bool);
    void autoAdjustWidthInPanel() const;
    void cacheTransparentBgImage(bool);
    QPixmap *getCachedBgPixmap() const;
    void setScreenFSBA(QPixmap&, int, PIXMAP_STRETCH_POLICY_E);
    QPixmap *getScreenFSBA();
    void setScreenSkinFile(QString);
    ZSkinService *getScreenSkinService();
    void setInternalWidget(bool);
    LayoutDirection getScreenLayoutDirection() const;
    void setResizeMethod(ZWidget::ResizeMethod);
    void setScreenLayoutDirection(ZWidget::LayoutDirection);

  protected slots:
    virtual void slotResizeChild();

  signals:
    void needResize();

  private:
    char _zwidget_stuff[4];
};

#endif
